.nolist
include	\masm32\include\masm32rt.inc

.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
include \masm32\Gfa2Masm\Cyct_Macros.inc

R8ToStr proto :real8,:PTR
include Int3264ToStr.asm
include Convert.inc

R8_BIAS equ 1023
R8_MANT equ 52

.xmm

cyctSleepMs = 	30
cyctShowSize = 	0
ChkTable =	0	; 1.000000000000000001e+87
ChkTable10 =	1	; use REAL10 to display table values 
ShowConstants =	1
ShowSteps =	0

LOOP_COUNT	= 10000
LOOP_COUNT2	= 50000
TestCt	= 15

F2Asc	PROTO: DWORD, :DWORD

COMMENT ^ see [url=http://www.asmcommunity.net/board/index.php?topic=14102.msg110555#msg110555]here[/url]
tmp$ CATSTR <mov edx, >, <offset f2sSlots>
% echo tmp$
tmp$
@CatStr(<mov edx, >, <offset f2sSlots>) ^

; --------  FloatAndCalc equates ------------
f2sPrec = 	7	; ->f2sDigits; max 16 digits (7 is default for FloatToStr)
SwScNot = 	-3	; if exponent < n, switch to scientific notation
ExRange equ	150	; range ca. e-150...e+150
signed	EQU sdword ptr 

Str$ MACRO strformat, num	;;, arg2, arg3
LOCAL P$, PP, PP_o, parseLen, c$, co$, AriMode, AriMult, CurAri, LastAri, NegFlag, CurNum$, argct, slot$, aSize1, HasDot
LOCAL f2sMS, ArgType, atyB, asiB, tmp$, quotes, arg1a, arg2a, arg3a, arg4a, mode$, FF$, nustr, IsReal
LOCAL aPass1, aPass2, aPass3, aPass4	; ArgSize global for TestNum
; strformat from slot not foreseen
; tmp$ CATSTR <Number=>, <num>
; % echo tmp$
  push edx
  mov edx, offset f2sSlots
  HasDot	= 0	;; immediate reals, 1.234e44
  NegFlag	= 0	;; if a para starts with -
  f2sMS	= 0	;; combined mode and size parameter
  argct	= 0	;; argument counter (4 num args max)
  PP	= 0	;; startpos in parse$
  PP_o	= 1	;; ParsePos old
  ; ArgSize	= 0	;; for TestNum
  ; AriMode	= 0	;; arithmetic mode
  LastAri	= 0	;; prev mode, e.g. 123+MyInt* when * is found
  AriMult	= 1	;; ari multiplier
  IsReal	= 0	;; default: integer
  quotes	INSTR <strformat>, <">
  if quotes eq 0
	quotes	INSTR <strformat>, <'>
  endif
  if quotes eq 1
	P$ CATSTR <num>, <>		;; first arg is a format string
	FF$ equ <offset nustr>		;; we pass it as FF$
	.data
		nustr db strformat, 0		;; write arg to .DATA section
	.code
  else
	P$	CATSTR <strformat>, <>	;; first arg is not format but the number itself
  endif
 
  parseLen SIZESTR P$

; tmp$ CATSTR <We scan >, P$, <, >, %parseLen, < bytes>
; % echo tmp$

  WHILE PP lt parseLen	; Repeat until Parse Position >= LEN(P$)
	PP=PP+1	; Position in Parse$
	c$ SUBSTR P$,PP,1
	CurAri INSTR <+-*/.eE>, c$	; 1234; and 8: neg before continuing
	if CurAri eq 2
		if PP eq PP_o
			NegFlag=32
			CurAri=0
			PP_o=PP+1
;			tmp$ CATSTR <MINUS: pp=>, %PP, <, ppo=>, %PP_o
;			% echo tmp$
		endif
	endif
	if CurAri eq 6
		HasDot = 1
		IsReal = 1
;		% echo ThisStringHasDot: <P$>
		CurAri = 0
	endif
	if CurAri gt 6
		CurAri = 0
		tmp$ SUBSTR P$, 1, PP
		if HasDot
			PP = PP + 1	;; skip 123e+1
;			tmp$ CATSTR <We skipped >, tmp$
;		else
;			tmp$ CATSTR <NO DOT in >, tmp$
		endif
;		% echo tmp$
	endif
	if CurAri
		CurNum$ SUBSTR P$,PP_o,PP-PP_o
		CurMS = LastAri + 8 * ChkNum(CurNum$)+NegFlag
		if NumSize
			IsReal = 1
		endif
		f2sMS = f2sMS + AriMult * CurMS	;; mode (bits 0-2, 0-7) and NumSize (bits 3-5, 8*(0-3), bit 6 reserved for NegFlag)
		LastAri = CurAri
		NegFlag = 0		;; clear the flag
;		tmp$ CATSTR <We pass >, aPass$, < with numsize >, %NumSize
;		% echo tmp$
		mov [edx], aPass$
		add edx, 4

;		tmp$ CATSTR <ModeSize=>, %f2sMS
;		% echo tmp$
		AriMult = AriMult * 64		;; 5*6=30: 0...7 sizes: 0=fild, 1=R4, 2=R8, 3=R10, 0...7 ari, 8=neg 000 001 010 011 100 101 110 111
		; % aPass1 equ aPass$
		if argct
			slot$ CATSTR <mov [edx+>, %argct*4, <], >, aPass$
		else
			slot$ CATSTR <mov [edx], >, aPass$
			ArgSize = NumSize		;; for TestNum
		endif
		argct = argct + 1
		if argct eq 6
			echo too many arguments
			.err
		endif
		PP_o = PP+1
		HasDot = 0
;		% echo slot$
;		echo
	endif
  ENDM
  ifndef FF$
  	if IsReal
	  	FF$ equ <0>
	 else
	  	FF$ equ <1>
	 endif
  endif
  invoke F2Asc, FF$, f2sMS		; not sure if % before inv is useful
  pop edx
  EXITM <( eAx )>	; the blanks left and righr of eAx are an important flag
ENDM
atImmediate	equ 36	; 00100100
atGlobal	equ 42	; 00101010
atRegister	equ 48	; 00110000
atLocal	equ 98	; 01100010

ChkNum MACRO argX:REQ
LOCAL ArgType, tmp$, arg, nu8, dot, deco, twocolons
  aPass$ equ <0>					;; several times redefined, no problem...!
  arg equ <argX>					;; sizes: 0=fild, 1=R4, 2=R8, 3=R10
  NumSize = -1					;; global return value, -1=error
  ifb <argX>
	crash
	EXITM <0>					;; no argument passed
  endif
  dot INSTR arg, < >				;; leading space?
  if dot eq 1
	arg SUBSTR arg, 2			;; strip one leading space
  endif
  dot INSTR arg, < >				;; leading space?
  if dot
	arg SUBSTR arg, 1, dot-1		;; strip trailing spaces
  endif
  dot INSTR arg, <.>				;; immediate real, or variable with dot, e.g. chrg.cpMin?
  if dot
  	tmp$ SUBSTR arg, dot-1, 1
  	dot INSTR <0123456789>, tmp$
;  	echo HasDot=%dot
  endif
  twocolons INSTR arg, <::>
  deco INSTR arg, <@>			;; REAL4, size 4 but decorated?
  if deco eq 0
	deco INSTR arg, <eal4>		;; dirty hack for TestNum
  endif
;  tmp$ CATSTR <t=>,<arg>, <, hasdot=>, %dot, <, hasdeco=>, %deco
;  % echo tmp$
  if deco
  	if deco eq 1						;; to distinguish Real4 from Int32,
		arg SUBSTR arg, 2			;; we decorate with a @
;		% echo <arg> was decorated
	endif
	NumSize = 1				;; REAL4
	ArgType = (opattr(arg)) AND 127
	if ArgType eq atLocal
		t$ CATSTR <lea eax, >, <arg>
		t$
		aPass$ equ eax			;; eax will be trashed when using a LOCAL
		t$ equ <Local REAL4>
	else
		aPass$ CATSTR <offset >, <arg>
		t$ equ <REAL4>
	endif
  elseif twocolons
  	tmp$ SUBSTR arg, twocolons+2		; edx::eax
  	mov dword ptr MbTmpQw, tmp$
  	tmp$ SUBSTR arg, 1, twocolons-1	; edx::eax
	ifidni <edx>, tmp$
		mov eax, [esp]			;; edx was pushed above
	  	mov dword ptr MbTmpQw[4], eax
	else
	  	mov dword ptr MbTmpQw[4], tmp$
	endif
  	aPass$ equ <offset MbTmpQw>
  	NumSize=6					; 1+2+3 - NegFlag must be cleared in Float2Asc

   elseif dot
	.data
		nu8 REAL8 arg			;; write arg to .DATA section
	.code
	NumSize = 2				;; Real8
	aPass$ equ <offset nu8>	;; we pass it as a pointer to the new Real8
	t$ equ <immediate Real8>
  else								;; none of the above
	ArgType = (opattr(arg)) AND 127			;; 0 no vn$, 36 immediate, 42 global, 48 CPU register, 98 local
	if ArgType eq atLocal or ArgType eq atGlobal
		RealSize = SIZEOF arg	;; 4 for DWORD, 10 for REAL10
		if RealSize eq 4
			NumSize = 0	;; Integer
			tmp$ CATSTR <mov eax, >, <arg>
;			% echo tmp$
			tmp$				;; insert code
			aPass$ equ eax		;; eax will be trashed
			t$ equ <Int32>
;			% echo t$
;			% echo aPass$
;			echo
		elseif RealSize eq 2
			NumSize = 0	;; Integer
			tmp$ CATSTR <movzx eax, word ptr >, <arg>
;			% echo tmp$
			tmp$				;; insert code
			aPass$ equ eax		;; eax will be trashed
		elseif RealSize eq 1
			NumSize = 0	;; Integer
			tmp$ CATSTR <movzx eax, byte ptr >, <arg>
;			% echo tmp$
			tmp$				;; insert code
			aPass$ equ eax		;; eax will be trashed
		else
			if ArgType eq atLocal
				tmp$ CATSTR <lea eax, >, <arg>
				tmp$				;; insert lea code (instead of addr)
				aPass$ equ eax		;; eax will be trashed when using a LOCAL
			else
				aPass$ CATSTR <offset >, <arg>
			endif
			if RealSize eq 8
				NumSize = 2	;; Real8
				t$ equ <REAL8>
			elseif RealSize eq 10
				NumSize = 3	;; Real10
				t$ equ <REAL10>
			else
				tmp$ CATSTR %RealSize, < for >, <arg>
				echo
				% echo Size tmp$ no good, sorry
				echo use integers or real numbers
				echo @-decorate REAL4 as deb 1, "Test", @MyReal4
				echo
				NumSize = 0
				.err
			endif
		endif
	elseif ArgType eq atImmediate
;		tmp$ CATSTR <Immediate passed: >, arg
;		% echo tmp$
		NumSize = 0			;; immediate integer
		tmp$ CATSTR <mov eax, >, <arg>
		tmp$
		aPass$ equ eax			;; push it using eax
		t$ equ <immediate DWORD>
	elseif ArgType eq atRegister
		RealSize SIZESTR arg
		NumSize = 0			;; register as int32
		if RealSize eq 3			;; full size register
			ifidni <edx>, arg
				mov eax, [esp]		;; edx was pushed above
				aPass$ equ eax		;; eax will be trashed 
			else
				aPass$ equ arg		;; push it "as is"
			endif
			t$ equ <DWORD reg>
		else
;			% echo checking register for <arg>
			t$ SUBSTR arg, 1, 1		;; e.g. ax, ah, el, cx
;			% echo t$
			tmp$ CATSTR <movzx e>,t$, <x, >, <arg>
;			% echo tmp$
			tmp$	; insert code, e.g. movzx ecx, cl
			aPass$ CATSTR <e>, t$, <x>	; ecx etc
;			% echo aPass$
			dot INSTR arg, <x>
;			tmp$ CATSTR <dooot >,%dot, < for >, arg
;			% echo tmp$
			if dot eq 0
				t$ equ <BYTE reg>
			else
				t$ equ <WORD reg>
			endif
;			% echo t$
		endif
	endif
  endif
  if NumSize lt 0
	 tmp$ CATSTR arg, < is type >, %ArgType, < with size >, %NumSize
	% echo tmp$
	.err
  endif
  EXITM <NumSize>
ENDM

.data?
f2sTmpBuf	dd 10 dup(?)	; internal buffer for f2sForm$
f2sSlots	dd 6 dup(?)	; 5+1 for flagging last slot
f2sR10	REAL10	ExRange*2 dup(?)	; ex-f2sP10
f2sOlly	dd ?
f2sDummy	dw ?
f2sBuffer	dd 80 dup(?)	; returned by float$

.data
f2sSeed	REAL10		1.0e-144
; xstep = 11	; 11 : 996 : 0005 gives perfect table
; f2s0dot99	REAL10		9.999999999999999996
; f2s0dot1	REAL10		10.0000000000000000005
f2sRndo5	REAL4		0.5	; is exact as REAL4
f2sRndExp	REAL4		0.00000000000000008	; correction for exponent (05 is not enough)
PI	REAL10 3.1415926535897932384626

.data?
StepCt	dd ?
;MyInitA8	REAL8 ?
buffer	db 100 dup(?)

cyctSize	dd ?
cyctStrLen	dd ?
cyctCounter	dd ?, ?, ?, ?, ?
cyctSortTable	dd 1000 dup(?)	; overwrites next dd
cyctTableMode	SDWORD ?
MbTmpQw	dq ?

MyPI	REAL10 ?
MyPI8	REAL8 ?
MyPI8Show	REAL8 ?
MyLog2E	REAL10 ?
MyLog2E8	REAL8 ?
MyLog2T	REAL10 ?
MyLog2T8	REAL8 ?
MyLogT2	REAL10 ?
MyLogT28	REAL8 ?
MyLogE2	REAL10 ?
MyLogE28	REAL8 ?

.data
MyReal8	REAL8	1234.5678
MyReal10	REAL10	1234.5678
MyInitB	REAL10	256.0		; Test
MyInitB8	REAL8	0.0
MyStepB	REAL10 100000000000000000.0

MyInitA	REAL10	0.1
MyInitA8	REAL8	0.0
MyStep	REAL10 0.000000000000001

Test4a	Real10	9.9999999999999999996e+17
Test4b	Real10	1.0000000000000000000e+18	; is exact...!
Test4c	Real10	1.0000000000000000001e+18

;f2sHigher	REAL4	10.0
;f2sLower	REAL4	1.0

;0.1000000000000013
;0.1000000000000014
;0.1000000000000016
;0.1000000000000017

.code
start:
;	fld Test4a
;	fld Test4b
;	fld Test4c
;	int 3
	; call GetCurve
	if ShowConstants
				finit
	fldpi		; we push the exact PI
	fst MyPI8		; a REAL8 for crt_printf
	fstp MyPI		; a REAL10 for Str$
	if 0
	mov eax, Str$("\nPI=\t%Jf", MyPI)
;	int 3
	mov eax, Str$("\nPI=\t%Jf", MyPI)
	mov ebx, -21
	.Repeat
		inc ebx
	
		if 0
		mov eax, dword ptr MyPI
		add eax, ebx
		mov dword ptr MyPI, eax
		inc f2sOlly
		print Str$("\nPI=\t%Jf", MyPI)
		
		else
		mov eax, dword ptr MyPI8
		add eax, ebx
		mov dword ptr MyPI8Show, eax
		mov eax, dword ptr MyPI8[4]
		mov dword ptr MyPI8Show[4], eax
		print Str$("\nn=%i\t", ebx)
;		.if ebx==0
;			inc f2sOlly
;			if 0
;			int 3
;			endif
;		.endif
		print Str$("%Jf", MyPI8Show)
		.if ebx==0
			print Str$("\n*** PI=\t%Jf", MyPI)
		.endif
		endif
	.Until ebx==20
	endif

	fldl2e		; Log2(e)
	fst MyLog2E8
	fstp MyLog2E

	fldl2t		; Log2(10)
	fst MyLog2T8
	fstp MyLog2T

	fldlg2		; Log10(2)
	fst MyLogT28
	fstp MyLogT2

	fldln2		; Loge(2)
	fst MyLogE28
	fstp MyLogE2

	print chr$(13, 10, 10, "Testing float$", 13, 10, 9, "1234567890123456789 digits precision")
	print chr$(13, 10, "PI", 9, "3.14159265358979323846 (there are many more digits...)", 13, 10, "Str$", 9)
	print Str$("%If\ncrt\t", MyPI)
	invoke crt_printf, chr$("%.17f"), MyPI8
	print chr$(9, "  (CRT printf or sprintf)")
	print chr$(13, 10, "R8ToStr", 9)
	invoke R8ToStr, MyPI8, offset f2sBuffer
	print offset f2sBuffer, 9, "  (drizz)"
	print chr$(13, 10, "FloatTo", 9)
	invoke FloatToStr, MyPI8, offset f2sBuffer
	print offset f2sBuffer, 9, 9, "  (Masm32 lib FloatToStr)"

	print chr$(13, 10, 10, "Log2(e)", 9, "1.4426950408889634070", 13, 10, "Str$", 9)
	print Str$("%If\ncrt\t", MyLog2E)
	invoke crt_printf, chr$("%.17f"), MyLog2E8
	print chr$(13, 10, "R8ToStr", 9)
	invoke R8ToStr, MyLog2E8, offset f2sBuffer
	print offset f2sBuffer, 9, "  (drizz)"
	print chr$(13, 10, "FloatTo", 9)
	invoke FloatToStr, MyLog2E8, offset f2sBuffer
	print offset f2sBuffer

	print chr$(13, 10, 10, "Lg2(10)", 9, "3.3219280948873623480", 13, 10, "Str$", 9)
	print Str$("%If\ncrt\t", MyLog2T)
	invoke crt_printf, chr$("%.17f"), MyLog2T8
	print chr$(13, 10, "R8ToStr", 9)
	invoke R8ToStr, MyLog2T8, offset f2sBuffer
	print offset f2sBuffer, 9, "  (drizz)"
	print chr$(13, 10, "FloatTo", 9)
	invoke FloatToStr, MyLog2T8, offset f2sBuffer
	print offset f2sBuffer

	print chr$(13, 10, 10, "Lg10(2)", 9, "0.3010299956639811952", 13, 10, "Str$", 9)
	print Str$("%If\ncrt\t", MyLogT2)
	invoke crt_printf, chr$("%.17f"), MyLogT28
	print chr$(13, 10, "R8ToStr", 9)
	invoke R8ToStr, MyLogT28, offset f2sBuffer
	print offset f2sBuffer, 9, "  (drizz)"
	print chr$(13, 10, "FloatTo", 9)
	invoke FloatToStr, MyLogT28, offset f2sBuffer
	print offset f2sBuffer

	print chr$(13, 10, 10, "Lge(2)", 9, "0.6931471805599453094", 13, 10, "Str$", 9)
;	inc f2sOlly
	print Str$("%Jf\ncrt\t", MyLogE2)
	invoke crt_printf, chr$("%.17f"), MyLogE28
	print chr$(13, 10, "R8ToStr", 9)
	invoke R8ToStr, MyLogE28, offset f2sBuffer
	print offset f2sBuffer, 9, "  (drizz)"
	print chr$(13, 10, "FloatTo", 9)
	invoke FloatToStr, MyLogE28, offset f2sBuffer
	print offset f2sBuffer, 13, 10, 10
;				 getkey
;				 exit
	endif

	fldpi
	fst MyPI8
	fstp MyPI

	print "Testing float$/printf", 13, 10, "PI   ", 9, "3.1415926535897932384626433832795", 13, 10, "Str$", 9
	print Str$("%If\ncrt\t", MyPI)
	invoke crt_printf, chr$("%.17f"), MyPI8

	if ShowSteps
	print chr$(13, 10)
	mov StepCt, TestCt

	fld MyStepB
	fld MyInitB
	print "Digits", 9, "Str$_678901234567890", 9, "sprintf_901234567890"
	.WHILE StepCt
		fadd ST, ST(1)
		fst MyInitB8
		fld st
;		int 3
		fstp MyInitB
		; F=15 digits: 8.00000000000000e+17    800000000000000000.0
		.if StepCt==TestCt-9
			; inc f2sOlly
			; getkey
		.endif
		mov edx, Str$("\nValue\t%Jf", MyInitB)
		if 0
		xor ecx, ecx
		.Repeat
			inc ecx
			mov al, [edx+ecx]
		.Until al=="."
		mov byte ptr [edx+ecx+3], 0
		endif
		print edx, 9	
		; 9.000000000000001e+16   90000000000000016
		; invoke crt_printf, chr$("%15.1f"), MyInitB8
		invoke crt_sprintf, offset buffer, chr$("%15.1f"), MyInitB8
		print offset buffer

;		print real8$(MyInitA)
		dec StepCt
	.ENDW
	fstp st
	fstp st
	print chr$(13, 10, 10)

	mov StepCt, TestCt
	fld MyStep
	fld MyInitA
	print "Digits", 9, "Str$_6789012345678901", 9, "sprintf_9012345678901"
	.WHILE StepCt
		fadd ST, ST(1)
		fst MyInitA8
		fld st
;		int 3
		fstp MyInitA
		mov edx, Str$("\nValue\t%Jf", MyInitA)
		if 0
		xor ecx, ecx
		.Repeat
			inc ecx
			mov al, [edx+ecx]
		.Until al=="."
		mov byte ptr [edx+ecx+3], 0
		endif
		print edx, 9
		invoke crt_printf, chr$("%1.19f"), MyInitA8
		dec StepCt
	.ENDW
	fstp st
	fstp st

	endif ; ShowSteps
	print chr$(13, 10, 10)
;	finit
	mov eax, 1008
	push eax
	REPEAT 8-1
		dec dword ptr [esp]
		fild dword ptr [esp]
	ENDM
	pop eax
;	fld MyReal8
;	fstp st
;	print Str$("MyReal8 = %8f", MyReal8), 13, 10
;	int 3
;	deb 1, "FPU", ST(0), ST(1), ST(2), ST(3), ST(4), ST(5), ST(6), ST(7)
	; finit		; 3*zero on exit, or very slow (1000->4500 cycles on P4)
	usetm = 1
	if usetm

	 	cyct_begin
	 		REPEAT 1
			mov eax, Str$('%7f', MyPI)
			ENDM
		cyct_end <Str$('%7f', MyPI)>
		print Str$('\t%7f', MyPI), 13, 10

		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; \masm32\Gfa2Masm\FloatStr\FloatStr.asc, F2Asc proc
			mov eax, Str$("%Ff", MyPI8)
		counter_end
		print str$(eax), 9, "cycles for Str$    ", 9
		print offset f2sBuffer, 13, 10
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; \masm32\Gfa2Masm\FloatStr\FloatStr.asc, F2Asc proc
	invoke R8ToStr, MyPI8, offset f2sBuffer
		counter_end
		print str$(eax), 9, "cycles for R8ToStr", 9
		print offset f2sBuffer, 13, 10
	else
	invoke GetTickCount
	push eax
	mov ebx, LOOP_COUNT2
	.Repeat
		mov eax, Str$(MyPI8)
		dec ebx
	.Until Zero?
	invoke GetTickCount
	pop ecx
	sub eax, ecx
;	int 3
	print str$(eax), 9, "ticks for Str$", 13, 10
	endif

	if usetm
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; \masm32\Gfa2Masm\FloatStr\FloatStr.asc, F2Asc proc
			invoke FloatToStr, MyPI8, addr f2sBuffer
	counter_end
	print str$(eax), 9, "cycles for FloatToStr", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; \masm32\Gfa2Masm\FloatStr\FloatStr.asc, F2Asc proc
			invoke crt_sprintf, offset buffer, chr$("%.7f"), MyPI8
	counter_end
	print str$(eax), 9, "cycles for crt_sprintf", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; \masm32\Gfa2Masm\FloatStr\FloatStr.asc, F2Asc proc
			mov eax, 12345678
			invoke dwtoa, eax, offset buffer
	counter_end
	print str$(eax), 9, "cycles for dwtoa", 13, 10

	else
	invoke GetTickCount
	push eax
	mov ebx, LOOP_COUNT2
	.Repeat
		invoke FloatToStr, MyReal8, addr f2sBuffer
		dec ebx
	.Until Zero?
	invoke GetTickCount
	pop ecx
	sub eax, ecx
	print str$(eax), 9, "ticks for FloatToStr", 13, 10
	endif

	if ChkTable
	mov edi, offset f2sR10		; v v interleaving saves ca. 5 cycles -> hack?
	xor ebx, ebx
	.Repeat
		mov eax, ebx
;		.if eax==136	; || eax==9
;			inc f2sOlly
;		.endif
		ffree st(7)
		lea eax, [eax+4*eax]
		fld real10 ptr [edi+2*eax]
		fst MyReal8
		fstp MyReal10
		print chr$(13, 10, "n=")
		print str$(ebx), 9
		invoke crt_printf, chr$("%17.17e"), MyReal8
		if ChkTable10
			print Str$("\t%Je", MyReal10)
		else
			print Str$("\t%Je", MyReal8)
		endif
		inc ebx
	.Until ebx>=ExRange*2-2	;-120
	endif
	inkey chr$(13, 10, "--- ok ---", 13)
	exit
	
.code
F2Asc proc uses ecx edx\
	f2sForm$:DWORD,				; pointer to e.g. "The relation A:B is %f"
	f2sMS:DWORD					; pointer to ModeSize
LOCAL f2sTmp64:QWORD, f2sTmp80:REAL10
LOCAL f2sST0:REAL10, f2sST1:REAL10, f2sST2:REAL10, f2sST2a:REAL8
LOCAL f2sConWold:WORD, f2sConDummy:WORD, f2sConW:WORD
LOCAL f2sDigits:DWORD
LOCAL f2sExpo:DWORD
LOCAL f2sInt:DWORD, f2sEdi:DWORD
LOCAL dest:DWORD							; source is always non-slot
	push ebx								; save regs
	push edi
	push esi
	mov f2sDigits, f2sPrec			; default
	ForMLIB = 0
	if ForMLIB
	  call MbGetSetSlot			;  ---- v v v ----- F2Asc, eax=current slot address [url=+1]mgss[/url]
	  mov edi, eax
	  add edi, len(edi)						; add slot size
	  inc edi									; this solved the "early delimiter" bug
	  call MbCheckDestRotate			; ---- ^ ^ ^ ----- 2 calls, 23 cycles ---
	  if 0
		add edi, 3
		and edi, -4					; memalign edi, 4
		mov [MbSlots+8*ebx], edi		; edi aligned to protect the last source
	  endif
	  mov dest, edi
	  mov esi, edi							; we swap
	else
	  mov esi, offset f2sBuffer
	  mov dest, esi
	endif
	mov edi, f2sForm$				; FF$: do we have a string  la "The number %f is too small"?
	xor eax, eax
	.if edi==1
		dec edi
		inc eax
	.endif
	mov f2sInt, eax					; flag integer
	.if edi							; new: 1=IsReal
	@@:	mov al, [edi]			; xxx we copy the format string to the output buffer
			test eax, eax
			je @F
			cmp al, "%"
			je @F					; insert number: we are done here
			mov cx, [edi]
			cmp cx, "t\"				; tab?
			jne NoTab
			sub eax, 92-9			; mov al, 9
			inc edi
			jmp NoLf

	NoTab:	cmp cx, "n\"			; newline?
			jne NoLf
			sub eax, 92-13			; mov al, 13
			mov [esi], al
			inc esi
			inc edi
			sub eax, 3				; mov al, 10

	NoLf:	mov [esi], al
			inc edi
			inc esi
			jmp @B

	@@:	mov al, [edi+1]
			.if al=="i"
				inc f2sInt				; flag Integer
			.elseif byte ptr al>"0"
				.if byte ptr al<="9"		; Uppercase F = 15
					and al, 15
					inc edi
					mov f2sDigits, eax	; change precision
				.elseif byte ptr al<="J"	; Uppercase F = 15
					sub al, 55
					inc edi
					mov f2sDigits, eax	; change precision
				.endif
			.endif
			mov f2sForm$, edi	; we'll do the rest after we are finished ...
	.endif						; ... with the number, starting from current esi
	mov edx, offset f2sR10		; v v interleaving saves ca. 5 cycles
	mov ecx, [edx]
	.if ecx==0
		fclex					; clear exceptions; 34 cycles, so we do it only once
	.endif
	fstcw f2sConWold					; status word could be saved as fstsw ax,
	mov eax, dword ptr f2sConWold		; but no such instruction for Control word
	or ax, 011100000000b				; rounding mode DOWN,
	mov dword ptr f2sConW, eax		; precision max=64
	fldcw f2sConW						; set new control word
	Save3 = 0
	if Save3
	  fstp f2sST0					; save & free 3 registers: 3*(6+6)=36 cycles, in practice 10 per FPU register, 30 cycles
	  fstp f2sST1					; No. 2 saved
	else
	  ffree st(7)					; do NOT save 6+7
	  ffree st(6)
	endif
		.data
	if 1
xstep = 4	; 11 : 996 : 0005 gives perfect table
f2s0dot99	REAL10		10.000000000000000002
f2s0dot1	REAL10		10.0
	else
xstep = 11	; 11 : 996 : 0005 gives perfect table
f2s0dot99	REAL10		9.999999999999999996
f2s0dot1	REAL10		10.0000000000000000005
	endif
		.code
	mov edi, offset f2sSlots		; slot table - *****************
	.if ecx==0
		fld f2s0dot1				; ------- create multplier table --------
		fld f2sSeed				; 1.0e-144
		mov ecx, ExRange*2-1
		m2m eax, 3		; first iteration
		add edx, ExRange*2*10-2*10
		;			12345678901234567890123456789012
		mov ebx,	11111111111111111111111001111111b
	@@:
		dec eax
		.if Sign?
			rol ebx, 1	; ca. 60 tiny adjustments
			jc NoDec	; carry set?
			dec eax		; multiply two steps earlier (dec does not change carry flag)
NoDec:		adc eax, xstep
			fxch
			fstp st
			fld f2s0dot99	; 10.0
			fmul st, st(1)
			fxch
			fstp st
			fld f2s0dot1
			fxch
		.else
			fmul st, st(1)
		.endif
		fld st
;		int 3
		fstp REAL10 ptr [edx]		; f2sR10
		sub edx, 10
		dec ecx
		jne @B
		fstp st					; ST0 will be on top again
		fstp st					; ST0 will be on top again
	.endif

; slot 0 taken: it's float$; FF$ or 0, f2sMS, slot 0: arg0, slot 1: arg1 etc
; slots not taken: FF$ or 0, Real8

	mov ebx, f2sMS			; slots taken: AriMode + 8 * Size+ 32 * NegFlag
	mov edx, [edi]				; f2sSlots[0]; mov edi moved up for interleaving
	test edx, edx
	je f2sZero
;	.if edx					; non-mac mode disabled
		; ************************	  macro mode   *******************************************
;		.if f2sOlly
;			int 3
;		.endif

NxtSlot:	mov ecx, ebx			; mode & size
		sar ecx, 3
		and ecx, 7				; 3	; size only
		.if cl==2
			fld REAL8 ptr [edx]		; load from mem, 3 cycles
		.elseif cl==0
			; int 3 ; [url=\masm32\Gfa2Masm\Floor.asc]Floor.asc[/url]
			fild dword ptr [edi]		; push the integer in edx=[edi] (reg or immediate)
		.elseif cl==3
			fld REAL10 ptr [edx]		; load from mem, 6 cycles
		.elseif cl==1
			fld REAL4 ptr [edx]		; load from mem, 3 cycles
		.elseif cl==6
			and ebx, 111111111111111111111111011111b	; clear NegFlag
			fild qword ptr [edx]		; push the long integer in edx=[edi] (reg or immediate)
		.endif
		mov eax, ebx				; mode
		test eax, 32
		je @F
		fchs					; NegFlag: change sign
@@:		and eax, 7				; mode only
		.if eax
			.if al==1	
				fadd
			.elseif al==2
				fsub
			.elseif al==3
				fmul
			.elseif al==4
				fdiv
			.endif
			xor eax, eax
		.endif
		stosd					; flag old slot empty for next invoke
		mov edx, [edi]
		sar ebx, 6				; get next 6 bits for size and mode
		test edx, edx
		jne NxtSlot				; slot empty, so outta here
		; 12+15*16/32 ->15*16/32+12
		; 12*15+16/32 ->not possible, see [url=\masm32\Gfa2Masm\Parser.asc]Parser[/url]
		; ************************	  end of macro slots  ******************************************
;	.else
;		jmp f2sZero				; disabled, did not work properly
;		test ebx, ebx
;		je f2sZero				; 0.0 or invalid number
;		invoke MessageBox, 0, BIN$(ebx, f), chr$("EBX"), MB_OK
;		deb 0, "Test EBX", edx, ebx
;		jmp f2sZero				; 0.0 or invalid number
;		 fld REAL8 ptr [ebx]		; "normal" invoke instead of macro, load from mem=3 cycles
;		 .err
;	.endif
	xor ecx, ecx					; sign flag
	ftst							; test for zero
	mov edi, esi				; we want to insert the number into edi
	fstsw ax
	sahf
	je f2sZero					; 0.0
	jnc f2sPos					; above zero
	mov al, "-"
	fabs						; our number is negative
	mov [edi], al
	inc edi						; edi=start of abs(num)

f2sPos:
	.if f2sInt
		mov f2sEdi, edi			; save current address
		add edi, 30				; enough space for copying
		xor esi, esi				; no dot!
		mov f2sDigits, esi		; to fix edi
	.else						; --------- start real number ----------
		fld st						; store current number in FPU
;		 .if f2sOlly
;			int 3
;		 .endif
		fstp f2sTmp80
		fldlg2						; load LOG10(2) constant, 8 cycles: Log10(x)=Log2(x)*Log10(2)
		fxch
		fyl2x						; log, 196-329 cycles
		fld f2sRndExp				; 0.00000...1 - the three instructions cost roughly 3 cycles
		fadd st(1),st					; round the integer upwards, move result to st(1)
		fstp st						; pop ST
		fistp f2sExpo				; pop log10(num), i.e. exponent
		fld f2sTmp80
		mov esi, f2sExpo			; exponent
		mov eax, esi
		sub eax, f2sDigits								; eax is log10, subtract digits to get multiplier
		lea eax, [eax+4*eax]		; *5
		lea edx, [f2sR10+2*eax+10*(ExRange+6)]		; max precision is 8*2=16
		fld REAL10 ptr [edx]							; multiply the original number by 1.0 Exx
;		12 digits, expo=9, d=+3: esi=edi+9
;		12 digits, expo=15, d=-3: esi=edi+1, flag sci on
;		12 digits, expo=-1, d=-13: esi=edi+1, flag sci on
		.if signed esi>=0			; esi=f2sExpo
			.if esi>=f2sDigits
				xor esi, esi			; can't fit, so choose SciNot
			.endif
		.elseif signed esi>=SwScNot	; ------------- insert leading zeros ------------- v v
			mov al, "." 
			mov [edi+1], al			; Ascii 46 at pos 1
			add al, 2
			stosb					; mov [edi], al + inc edi: Ascii 48 at pos 0, i.e. leading 0
			mov edx, esi
			.While signed edx<-1	; write some zeros
				inc edi
				inc edx
				mov [edi], al
			.Endw
			or esi, -1				; no other dots please
		.else						; ------------- insert leading zeros ------------- ^ ^
			xor esi, esi				; can't fit, so choose SciNot
		.endif
		fmul						; normalise to a positive number (16 cycles)
		;int 3
		mov ebx, esi				; flag SciNot
		fld f2sRndo5				; 0.5 - the three instructions cost roughly 3 cycles
		fadd st(1),st					; round the integer upwards by adding 0.5, move result to st(1)
		fstp st						; pop ST
		mov eax, f2sDigits			; ----------- check for rounding 9.99999 problem ----
		neg eax
		lea eax, [eax+4*eax]		; *5
		lea edx, [f2sR10+2*eax+10*(ExRange+5)]		; get expected value from table
		fld REAL10 ptr [edx]			; load 10^n
		fsubr st, st(1)				; subtract current number
		ftst							; set flags
		fstsw ax					; pop flags
		sahf						; translate
		fstp st
		jb @F						; below: OK
		.if esi
			inc edi					; no SciNo: leave it there but move one dot to the right
		.else
			inc f2sDigits			; SciNo: fake a multiply by ten
			inc f2sExpo
		.endif						; ----------- rounding corrected ---------------------------------
@@:		add esi, edi					; pos to insert the dot, if any
		inc esi
	.endif						; -- f2sInt ------- end real number ----------
	if 0
;	int 3
	fld st
	fistp f2sTmp64
	mov eax, dword ptr f2sTmp64
	fadd f2sLower
	fld st
	fistp f2sTmp64
	mov eax, dword ptr f2sTmp64
	fsub f2sLower
	fld st
	fistp f2sTmp64
	mov eax, dword ptr f2sTmp64
	fsub f2sLower
	fld st
	fistp f2sTmp64
	mov eax, dword ptr f2sTmp64
	fistp f2sTmp64				; qword to mem - exit v v here for CALC
	mov eax, dword ptr f2sTmp64
		 .if f2sOlly
		 and eax, 127
			;int 3
		 .endif
	else
	fistp f2sTmp64
	endif
	add edi, f2sDigits			; edi is pointer to end of output buffer
	push edi
	cmp esi, edi
	jnz @F
	mov byte ptr [edi+1], "0"
;	int 3
	inc dword ptr [esp]
@@:	lea eax, f2sTmp64		; address of dword to convert
	call qw2Str			; convert to Ascii
	test ebx, ebx			; SciNot flag?
	jne @F
	movzx ecx, word ptr [eax+2]	; SciNot only
	.if cl!="."
		mov ecx, [eax+6]				; Problem: for numbers closely below 1.000 Ex, log yields upward rounded integer
		.if ecx=="9999"				; qw2str cannot handle them properly, so there will be no dot but rather 599999 or similar
			mov word ptr [eax-1], ".9"	; MIRROR$("9."), chokes with JWasm	; we fix the problem: 9.9999... E(x-1)
			dec f2sExpo
		.endif
	.endif
@@:	pop edi
	inc edi
	.if f2sInt
		mov edi, f2sEdi			; destination
		mov ecx, edi
		sub ecx, eax
		add ecx, 30
		inc eax
		mov esi, eax			; source returned from qw
		rep movsb
;		 deb 0, "Test", ecx, esi$, edi$
	.elseif ebx==0					; use scientific notation ...
		mov ecx, f2sExpo			 ; ... only if exponent <> 0
		.if ecx
			mov eax, "0+e"				; default
			.if signed ecx<SwScNot		; jge ...
				neg ecx
				add ah, 2				; = mov eax, "0-e"
			.endif
			mov [edi], eax				; +-e0
			mov eax, ecx
			push 10
			pop ebx
			; m2m ebx, 10
			xor edx, edx				; for div, edx must be zero; cdq?
			div ebx						; result in eax, remainder in edx
			add dl, 30h					; last number of exponent
			add edi, 2
			mov [edi+1], dl
			.if signed ecx>=100			; we need less space for the expo
				mov [edi+2], dl			; 96/10=9 in eax, 6 in edx
				xor edx, edx			; for div, edx must be zero
				div ebx					; divide eax by 10 again
				add al, 30h
				stosb					; 1 in eax to left (mov [edi], al+inc edi)
				mov al, dl				; 2 in edx to middle position
			.endif
			add al, 30h
			mov esi, edi
			stosb						; mov [edi], al, inc edi
			inc edi
		.endif
	.endif
	mov byte ptr [edi], 0				; zero delimiter

f2sDone:								; ------------	xxx finish the job  ------------------------
	mov esi, f2sForm$				; did the format string have text after the number?
	.if esi>1
			inc esi					; get rid of %f
	@@:	inc esi					; v v -------------
			mov al, [esi]
			test al, al
			je @F

			mov cx, [esi]
			cmp cx, "t\"				; tab?
			jne NoT2
			sub eax, 92-9			; mov al, 9
			inc esi
			jmp NoLf2

	NoT2:	cmp cx, "n\"			; newline?
			jne NoLf2
			sub eax, 92-13			; mov al, 13
			stosb
			inc esi
			sub eax, 3				; mov al, 10

	NoLf2:	stosb					;mov [edi], al + inc edi
			jmp @B					; ^ ^ -------------

	@@:	stosb					; mov [edi], al + inc edi
	.endif
	;int 3	; ffree??
	;nop
;	INT 3

	if 0 ; Save3
		fld f2sST2				; restore 3 registers
		pop esi					; restore regs, interleaved
		fld f2sST1
		pop edi
		fld f2sST0
		pop ebx
	elseif Save3

	lea esi, f2sST2
	m2m ecx, 3
	.Repeat
		movzx eax, word ptr [esi+8]
		or eax, 08000h
		xor eax, 0ffffh
		if 1
		.if Zero?
;			fdecstp			; turn the barrel, pushing direction: extremely slow here
			fldz				; push zero, 4 cycles?
;			ffree ST			; free the reg, 3 cycles in theory, thousands in practice
		.else
			fld REAL10 ptr [esi]		; restore previous value
		.endif
		elseif 1
		.if Zero?
			fdecstp				; turn the barrel, pushing direction
			; fldz				; push zero, 4 cycles?
			ffree ST				; free the reg, 3 cycles
		.else
			fld REAL10 ptr [esi]		; restore previous value
		.endif
		endif
		lea esi, [esi+10]
		dec ecx
	.Until Zero?
	pop esi					; restore regs
	pop edi
	pop ebx
	else
	pop esi					; restore regs
	pop edi
	pop ebx
	endif

	fldcw f2sConWold		; restore control word
	mov eax, dest			; Slot
  ret

f2sZero:
	mov edi, esi	; destination is still in esi
	.if f2sInt
		mov al, "0"		; put a nice zero
		stosb
	.else
		mov eax, "0.0"	; put a real zero
		stosd
		dec edi
	.endif
	fstp st							; ST0 will be on top again
	jmp f2sDone
F2Asc endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
qw2Str proc	; qw2Str needs ptr qword in eax, ptr buffer in edx
	push ebp			; credits to  drizz 
	; push edi
	nop
	push ebx
	push esi			; [esp]=esi
	nop
	mov esi, [eax]
	add eax, 4		; 2 bytes longer but 2 cycles faster than mov edi, [eax+4
	mov ebp, edi		; buffer pointer - here passed as edi
	mov edi, [eax]
	test edi, edi		; is there a hi dword? depends on precision...
	jz @F

  @@U64Cvt:	; QWORD conversion loop
	mov eax, 0CCCCCCCDh	; = b0
	mul esi			; get a0*b0 = d1:d0
	mov eax, 0CCCCCCCDh	; = b0 (mov eax up saves 1 cycle)
	mov ecx, edx		; d1
	xor ebx, ebx
	mul edi			; get a1*b0 = e1:e0
	add ecx, eax		; e0
	adc ebx, edx		; e1
	mov eax, 0CCCCCCCCh	; =b1
	mul esi			; get a0*b1 = f1:f0
	add ecx, eax		; f0
	adc ebx, edx		; f1
	push 0			; 5 cycles faster, 3 bytes shorter than mov ecx, 0
	pop ecx			; - don't trash the flags with xor ecx, ecx!
	mov eax, 0CCCCCCCCh	; =b1
	adc ecx, ecx
	mul edi			; get a1*b1 = g1:g0
	add eax, ebx		; g0
	adc edx, ecx		; g1
	shrd eax, edx, 3
	shr edx, 3			; ------ quotient in edx::eax

	; upper dwords will be the same after multiplication
	lea ecx, [eax*4+eax]	; ecx=5*eax
	neg ecx			; same speed, 2 bytes shorter
	lea ebx, [esi+2*ecx+"0"]
	mov esi, eax
	cmp ebp, [esp]		; 2 cycles, [esp]=esi
	je InsDot1		; 1 cycle
Dot1Ok:	mov [ebp], bl
	mov edi, edx
	sub ebp, 1		; dec ebp costs 1-2 cycles here
	test edi, edi
	jnz @@U64Cvt

  @@:	; we are here if HI-DWORD is 0
	mov eax, esi
	mov ebx, esi
	mov edi, 0CCCCCCCDh

	; Lower Dword conversion loop
  @@U32Cvt:	mul edi
	shr edx, 3
	lea ecx, [edx*4+edx]	; ecx=edx*5
	neg ecx			; 3 cycles faster
	lea ebx, [ebx+2*ecx+"0"]
	mov eax, edx		; sub ebx, mov eax 2 cycles faster than inverse sequence
	cmp ebp, [esp]		; 2 cycles
	je InsDot2		; 1 cycle
Dot2Ok:	mov [ebp], bl
	mov ebx, edx
	dec ebp			; sub ebp, 1 here a bit slower and 2 bytes more
	test eax, eax
	jnz @@U32Cvt

	mov eax, ebp		; first byte - needed for f2sInt	
	pop esi
	pop ebx
	; pop edi
	pop ebp
	ret

InsDot1:	mov byte ptr [ebp], "."
	dec ebp
	jmp Dot1Ok

InsDot2:	mov byte ptr [ebp], "."
	dec ebp
	jmp Dot2Ok

qw2Str endp
OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF
.const
; -------- end  FloatAndCalc ------------
.code
cyct_endP proc
  push ebp
  push esi
  push ebx
  push eax
  inc edx
  invoke CombSortA, offset cyctSortTable, edx
  xor ebx, ebx
  ; ifline cyctTableMode!<=0, print chr$(13, 10)
  if cyctShowSlow
	print chr$(10)
	.Repeat
  		print str$(ebx), ":"
		mov eax, [cyctSortTable+4*ebx]
		print str$(eax), " "
	  	inc ebx
	.Until ebx>cyctCutFast
	if cyctShowSlow gt 0
		print chr$(13, 10, 10, "...", 13, 10, 10)
		mov ebx, cyctCounter
		sub ebx, cyctShowSlow
		.Repeat
  			print str$(ebx), ":"
			mov eax, [cyctSortTable+4*ebx]
			print str$(eax), " "
  			inc ebx
		.Until ebx>=cyctCounter
	endif
  endif
  pop ebp	; pushed as eax
  if cyctShowDiff
  .if byte ptr [ebp]!="#"
	print chr$(13, 10)
	print ebp
	print chr$(13, 10, "average with cutoff", 9)
  .endif
  endif
  push cyctCutFast
  pop ebx
  mov eax, [cyctSortTable+4*cyctCutFast]		;; determine the cutoff value
  mov esi, eax			; eax is one of the lowest timings
  shr esi, 2			; /4
  inc esi
  add esi, eax			; esi = eax * 1.25 + 1
  xor eax, eax
  .Repeat
	mov ecx, [cyctSortTable+4*ebx]
	inc ebx
	.Break .if ecx>esi
	add eax, ecx
  .Until ebx>cyctCounter
  sub ebx, cyctCutFast+2
  je @F
  cdq
  div ebx
  @@:
  push eax
  .if cyctTableMode
	; printFix cyctColW, str$(eax)		; the actual cycles
  .else
	print str$(eax)
  .endif
  .if byte ptr [ebp]!="#"
	if cyctShowDiff
		.if ebx<=sizeof cyctSortTable/4-cyctCutFast-1
			print chr$(32, 9, "cutoff at n=")
			add ebx, cyctCutFast+1
			print str$(ebx), " for ", 62		; >n cycles
			print str$(esi), " cycles"
		.else
  			print chr$(32, 9, "no cutoff")
		.endif
		print chr$(13, 10, "average w/o cutoff ", 9)
	else
		.if cyctTableMode==0
			.if ebx<=sizeof cyctSortTable/4-cyctCutFast-1
				add ebx, cyctCutFast+1
				.if ebx<400
					print "*"
				.endif
			.endif
			print chr$(9)
			print ebp
		.endif
	endif
  .endif
  xor eax, eax
  xor ebx, ebx
  mov edx, cyctCounter
  .Repeat
	add eax, [cyctSortTable+4*ebx]
	inc ebx
  .Until ebx>edx
  test eax, eax
  js @F	; something is wrong here
  dec ebx
  je @F	; rare event
  cdq
  div ebx
  @@:
  mov ebx, eax
  .if byte ptr [ebp]!="#"
	if cyctShowDiff
		print str$(eax), 13, 10, "difference raw-cutoff:", 9
		sub ebx, [esp]
		print str$(ebx)
	endif
  .endif
  if cyctShowSize
	print "    ", 9, "codesize="
	print str$(cyctSize), " bytes"
  endif
  pop eax
  pop ebx
  pop esi
  pop ebp
  ret
cyct_endP endp

.data?
f2sR10b	REAL10	ExRange*2 dup(?)	; ex-f2sP10
tv	REAL10 ?
.code

GetCurve proc
LOCAL f2sToggle
		mov eax, Str$(tv)		; init table
		fld f2s0dot1				; ------- create multplier table --------
		fld f2sSeed				; 1.0e-144
		mov ecx, ExRange*2-1
		mov edx, offset f2sR10b
		m2m eax, 2		; first iteration
		add edx, ExRange*2*10-2*10
		;			12345678901234567890123456789012
		mov ebx,	11011111111111111111111111111111b	; 0=earlier add
		or f2sToggle, -1
		and f2sToggle, 0
		push esi
		push edi
		xor esi, esi		; test counter
		xor edi, edi		; test counter
	@@:
		inc esi
		if 0
		dec eax
		.if 0 ;Sign?
;			int 3
			xstep = 2
			if 1
				; add eax, xstep
			else
				rol ebx, 1
				adc eax, xstep
			endif
			dec f2sToggle
			test f2sToggle, 1
			fxch
			.if Zero?
				; fsub f2sSub
				rol ebx, 1
				adc eax, xstep-1
			;	int 3
				inc edi
			.else
				; fadd f2sAdd
				add eax, xstep
				add edi, 65536
			.endif
			fxch
		.endif
		endif
		fmul st, st(1)
		fld st

		; fstp REAL10 ptr [edx]		; f2sR10
		fstp tv
		pushad
		print Str$(esi), 9
		mov edi, Str$("%Jf", tv)
		print edi, 13, 10
		getkey
		; int 3
		popad
		sub edx, 10
		dec ecx
		jne @B
		pop edi
		pop esi
		fstp st					; ST0 will be on top again
		fstp st					; ST0 will be on top again
  ret
GetCurve endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

	align 16
R8ToStr proc r8:REAL8, lpBuffer:PTR

	tmpbuffsize equ 32
	saveregssize equ 4*4 
	locals equ tmpbuffsize + saveregssize + 4+4+4
	tmpbuff equ <[esp]>
	saveregs equ <[esp+tmpbuffsize]>
	dwSign equ <[esp+tmpbuffsize+saveregssize+0*4]>
	dwExp equ <[esp+tmpbuffsize+saveregssize+1*4]>
	dwTmp equ <[esp+tmpbuffsize+saveregssize+2*4]>
	pValue equ <[esp+locals+1*4]>
	pBuffer equ <[esp+locals+3*4]>

	sub esp,locals
	mov saveregs[0*4],ebp
	mov saveregs[1*4],esi
	mov saveregs[2*4],edi
	mov saveregs[3*4],ebx
	mov eax,pValue[4]
	mov esi,pValue[0]
	cdq
	and eax,01111111111111111111111111111111b; clear sign
	mov dwSign,edx
	mov edi,eax
	and edi,00000000000011111111111111111111b; high bits of mantissa
	shr eax,52-32
	cmp eax,11111111111b
	je @@NaNOrInfinity
	test eax,eax
	jz @@SubnormalOrZero
	or  edi,00000000000100000000000000000000b; + 1 implied
;	sub ebx,R8_BIAS;
;	sub ebx,R8_MANT ; move the "dot" from "11:zero:bits<implied:bit>.52bit:mant" to "<64:bit:uint>."
;	sub ebx,64-(R8_MANT+1); substract Log2(2^11)
	sub eax,R8_BIAS+R8_MANT+(64-(R8_MANT+1));
	mov ecx,(1 shl 6)-1 ;; (2^n) - 1
	mov ebx,eax
	shld edi,esi,64-(R8_MANT+1)
	shl esi,64-(R8_MANT+1)
	; divide by 64 (result should be in range -16..15), remainder in ecx
@@SubnormalReturn:	
	cdq 
	and edx,ecx 
	add eax,edx
	and ecx,eax
	sar eax,6
	sub ecx,edx
	;dbg T("{Unpack.} %I64u *2^%i, div64=%i, mod64=%i",13,10),edi::esi,ebx,eax,ecx
	mov edx,eax
	xor ebp,ebp; decexp
	sal edx,6;imul edx,eax,64
	sub ebx,edx; binexp -= ((expdiv64) * 64)
	sub ebp,tab_2x10x_div_exp[eax*4+16*4]
	mov dwTmp,ecx; ecx=(int)(binexp%64)
	mov dwExp,ebp; decexp
	mov ebp,eax; eax=(int)(binexp/64)

	;dbg T("Mulc = %I64u",13,10),tab_2x10x_div[eax*8+16*8]
	;; edi::esi *= tab_2x10x_div[eax*8+16*8]
	_mul_64x64_top64 tab_2x10x_div[ebp*8+16*8][0],tab_2x10x_div[ebp*8+16*8][4]
	;dbg T("{after mul.} %I64u *2^%i *10^%i",13,10),edi::esi,ebx,ebp
	mov ebp,dwTmp
	test ebp,ebp
	.if !zero?
		movsx edx,tab_2x10x_mod_exp[ebp+64]
		add dwExp,edx
		;dbg T("Mulc = %I64u",13,10),tab_2x10x_mod[ebp*8+64*8]
		;; edi::esi *= tab_2x10x_mod[ecx*8+64*8]
		_mul_64x64_top64 tab_2x10x_mod[ebp*8+64*8][0],tab_2x10x_mod[ebp*8+64*8][4]
		;dbg T("{after mul.} %I64u *2^%i *10^%i",13,10),edi::esi,ebx,0
	.endif
	; 40 cycles for converting from n*2^m to x*10^y

	ReduceAndRoundTo15Digits

	InternalR8Format3
	
@@Done:
	mov eax,edi	
	mov ebp,saveregs[0*4]
	mov esi,saveregs[1*4]
	mov edi,saveregs[2*4]
	mov ebx,saveregs[3*4]
	add esp,locals
	sub eax,[esp+3*4]
	ret REAL8 + DWORD
	
@@NaNOrInfinity:
	mov ebx,edi
	mov eax,edi
	mov ecx,dwSign
	mov edi,pBuffer
	xor edx,edx
	mov dl,cl
	and dl,'-'
	mov [edi],dl
	sub edi,ecx
	or eax,esi
	mov dword ptr [edi],'#.1'	
	.if zero?
		mov eax,'FNI'
		mov [edi+3],eax	
		add edi,6
		jmp @@Done
	.endif
	.if ebx > 7FFFFH
		mov eax,'NANQ'
		mov [edi+3],eax	
		mov byte ptr [edi+7],0
		add edi,7
		jmp @@Done
	.endif

;	test esi,esi
;	.if sign?
		mov eax,'NANS'
		mov [edi+3],eax	
		mov byte ptr [edi+7],0
		add edi,7
		jmp @@Done
;	.endif
;	mov eax,'DNI'
;	mov [edi+3],eax	
;	add edi,6
;	jmp @@Done

@@Zero:
	mov ecx,dwSign
	mov edi,pBuffer
	xor edx,edx
	mov dl,cl
	and dl,'-'
	mov [edi],dl
	sub edi,ecx
	mov word ptr [edi],'0'	
	add edi,1
	jmp @@Done

@@SubnormalOrZero:
	mov edx,esi
	or edx,edi
	or edx,eax
	jz @@Zero

	mov eax,-1022-R8_MANT

	.if !edi
		mov edi,esi
		xor esi,esi
		sub eax,32
	.endif
	
	mov ecx,31
	bsr edx,edi
	sub ecx,edx
	sub eax,ecx
	shld edi,esi,cl
	shl esi,cl
	
	mov ebx,eax
	mov ecx,(1 shl 6)-1 ;; (2^n) - 1

	jmp @@SubnormalReturn

R8ToStr endp 
%echo R8ToStr: @CatStr(%($-R8ToStr)) bytes

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF


end start

RichMasm options:
OPT_Linker	link	; If present in \bin, PoLink.exe will be used by default; delete the x to force link.exe
OPT_Assembler	ml	; If present in \bin, JWasm.exe may be used: just delete the x 

OPT_DebugA	/Zi /Zd
OxPT_DebugL	/debug 		; /debugtype:cv /MERGE:.rdata=.text	; for ultra short executables
OPT_Tmp2Asm	1
OPT_Wait	0
OPT_DelTmp	0



n=159   1.00000000000000000e-004        1.000000000000000001e-04
n=160   1.00000000000000010e-005        1.000000000000000001e-05
n=161   9.99999999999999950e-007        1.000000000000000001e-06
n=162   9.99999999999999950e-008        1.000000000000000001e-07
n=163   1.00000000000000000e-008        1.000000000000000000e-08



		fld f2s0dot1				; ------- COPY create multplier table --------
		fld f2sSeed				; 1.0e-144
		mov ecx, ExRange*2-1
		mov edx, offset f2sR10b
		m2m eax, 2		; first iteration
		add edx, ExRange*2*10-2*10
		;			12345678901234567890123456789012
		mov ebx,	11011111111111111111111111111111b	; 0=earlier add
		or f2sToggle, -1
		and f2sToggle, 0
		push esi
		push edi
		xor esi, esi		; test counter
		xor edi, edi		; test counter
	@@:
		inc esi
		if 1
			mov edi, 0
		else
		dec eax
		.if Sign?
;			int 3
			xstep = 2
			if 1
				; add eax, xstep
			else
				rol ebx, 1
				adc eax, xstep
			endif
			dec f2sToggle
			test f2sToggle, 1
			fxch
			.if Zero?
				fsub f2sSub
				rol ebx, 1
				adc eax, xstep-1
			;	int 3
				inc edi
			.else
				fadd f2sAdd
				add eax, xstep
				add edi, 65536
			.endif
			fxch
		.endif
		endif
		fmul st, st(1)
		.if esi>edi
;			int 3
		.endif
		fld st
;		int 3
		fstp REAL10 ptr [edx]		; f2sR10
		sub edx, 10
		dec ecx
		jne @B
		pop edi
		pop esi
		fstp st					; ST0 will be on top again
		fstp st					; ST0 will be on top again
